/**
@author Cesar Vasquez Ibaceta
@version 1.0 13-04-2004
*/

import javax.swing.*;
import java.lang.String.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;
import java.awt.Toolkit.*;
import java.awt.geom.*;
import java.awt.Graphics2D.*;



/**
	Clase Principal, ella se encargara de crear nuestras ventanas y paneles.
*/
public class editor
{
	/**
		Este constructor, crea un Frame en donde iran el resto de nuestros objetos.
		Ademas setea la opcion de "salir de la aplicacion al cerrar la ventana"
	*/
	public static void main(String[] args)
	{
		MainFrame frame = new MainFrame();
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.show();
	}
}


/**
	Clase para crear nuestra Ventana principal, ademas se escarga de setear el
	tamao de nuestra ventana y pocision en la pantalla.
*/
class MainFrame extends JFrame
{
	/**
	@param MPanel Es nuestro Panel Principal.
	*/
	private mainPanel MPanel;

	/**
		Se encarga de crear nuestra Ventana Principal, ademas de agregarle un Panel
		Principal (MPanel). Tambien se encarga de darle ciertos rasgos a nuestra
		ventana como tamao y posicion dentro de la pantalla.
	*/
	public MainFrame()
	{
		Toolkit Screen = Toolkit.getDefaultToolkit();	//leemos el tamo de la pantalla para poder
		Dimension screenSize = Screen.getScreenSize();  //hacer nuestra ventana de un tamao proporcional.

		int scHeight = screenSize.height;
		int scWidth = screenSize.width;

		setTitle("JavaPaint");
		setSize( scWidth / 2 , 3 * scHeight / 4 );		//tamao de la ventana
		setLocation( scWidth / 4 , scHeight / 8 );		//pocision de la ventana

		MPanel= new mainPanel();
		Container contentPane = getContentPane();
		contentPane.add(MPanel);						//agregamos nuestro panel principal.
	}
}


/**
	clase para crear nuestro Panel Principal.
*/
class mainPanel extends JPanel
{
	private buttonPanel BPanel1;
	private buttonPanel BPanel2;
	private drawPanel DPanel;
	private ArrayList elipses;
	private ArrayList lineas;
	private ArrayList rectangulos;
	private Ellipse2D E;
	private Rectangle2D R;
	private Line2D L;
	private double d1;
	private double d2;

	/**
		Este constructor, crea un panel principal, y se encarga de crear dos paneles mas,
		llamando a las clases buttonPanel y drawPanel. <BR>Tambien agrega botones a BPanel,
		segun el metodo agregarBoton de la clase buttonPanel y agrega un ActionListener a
		dichos botones.<BR>
		Ademas se encarga de inicializar nuestras variables.
	*/
	public mainPanel()
	{
		elipses =  new ArrayList();
		lineas =  new ArrayList();
		rectangulos =  new ArrayList();
		E = null;
		R = null;
		L = null;
		d1 = 0;
		d2 = 0;

		ActionListener PButton = new pressButton();	//use un action listener para todos los botones.

		setLayout(new BorderLayout());

		BPanel1 = new buttonPanel(1,4,3);	//se crean los paneles.
		BPanel2 = new buttonPanel(1,3,3);
		DPanel = new drawPanel();

		/* agrego los botones al panel, mediante el metodo "agregarBotom"
			de la clase "buttonPanel" */
		BPanel1.agregarBoton("escalar", PButton);
		BPanel1.agregarBoton("rotar", PButton);
		BPanel1.agregarBoton("mover", PButton);
		BPanel1.agregarBoton("limpiar", PButton);
		BPanel2.agregarBoton("ELIPSE", PButton);
		BPanel2.agregarBoton("RECTANGULO", PButton);
		BPanel2.agregarBoton("LINEA", PButton);

		add(BPanel1, BorderLayout.NORTH);	//se agregan los paneles
		add(BPanel2, BorderLayout.SOUTH);
		add(DPanel, BorderLayout.CENTER);
	}


	/**
		Clase interna, que implementa a la clase ActionListener.
		Es la encargada de detectar cuando alguien presiona un boton.
	*/
	private class pressButton implements ActionListener
	{
		String option;
		/**
			Detecta cuando se presiona un boton, y envia el nombre del boton a la
			clase drawPanel por medio del metodo <i><b>parametro</b></i>.
			@param event entrega el nombre del boton que fue presionado.
		*/
		public void actionPerformed(ActionEvent event)
		{
			option = event.getActionCommand();		//cuando un boton es presionado, se llama al metodo
			DPanel.parametro(option);				//parametro para pasarle las variables que usara el
													//panel de dibujo (DPanel)
		}
	}
}

